StarZone Class Reference documentation

StarZone Class Reference

a zone in a StarOffice file More...

`#include <StarZone.hxx>`

## Public Member Functions
| StarZone (STOFFInputStreamPtr input, std::string const &ascName, std::string const &zoneName, char const *password)
| constructor
virtual | ~StarZone ()
| destructor
bool | readSWHeader ()
| read the zone header present in a SW file
bool | checkEncryption (uint32_t date, uint32_t time, std::vector< uint8_t > const &passwd)
| check encryption
bool | openSDRHeader (std::string &magic)
| open a zone header present in a SDR file
bool | closeSDRHeader (std::string const &debugName)
| close a zone header
bool | openSCHHeader ()
| open a zone header present in a SCH file
bool | closeSCHHeader (std::string const &debugName)
| close a zone header
bool | openVersionCompatHeader ()
| open a version compat header (version+size)
bool | closeVersionCompatHeader (std::string const &debugName)
| close a zone header
int | getVersion () const
| returns the StarOffice version: 3-5
int | getDocumentVersion () const
| returns the StarOffice document version
int | getHeaderVersion () const
| returns the StarOffice header version (if set)
int | isCompatibleWith (int vers) const
| checks if the document is compatible with vers
int | isCompatibleWith (int vers1, int vers2) const
| checks if the document is compatible with vers1 and not vers2
int | isCompatibleWith (int vers1, int vers2, int vers3) const
| checks if the document is compatible with vers1 and not vers2 or vers3
int | isCompatibleWith (int vers1, int vers2, int vers3, int vers4) const
| checks if the document is compatible with vers1 and not vers2 or vers3 and not vers4
StarEncoding::Encoding | getEncoding () const
| returns the zone encoding
void | setEncoding (StarEncoding::Encoding encod)
| sets the zone encoding
int | getGuiType () const
| returns the zone GUI type
void | setGuiType (int type)
| sets the zone GUI type
bool | openRecord ()
| try to open a classic record: size (32 bytes) + size-4 bytes
bool | closeRecord (std::string const &debugName)
| try to close a record
bool | openDummyRecord ()
| open a dummy record
bool | closeDummyRecord ()
| close a dummy record
bool | openSCRecord ()
| try to open a SC record: size (32 bytes) + size bytes
bool | closeSCRecord (std::string const &debugName)
| try to close a record
bool | openSWRecord (char &type)
| try to open a SW record: type + size (24 bytes)
bool | closeSWRecord (char type, std::string const &debugName)
| try to close a record
bool | openSfxRecord (char &type)
| try to open a Sfx record: type + size (24 bytes)
bool | closeSfxRecord (char type, std::string const &debugName)
| try to close a record
int | getRecordLevel () const
| returns the record level
long | getRecordLastPosition () const
| returns the actual record last position
unsigned char | openFlagZone ()
| try to open a cflag zone
void | closeFlagZone ()
| close the cflag zone
long | getFlagLastPosition () const
| returns the flag last position
bool | readString (std::vector< uint32_t > &string, int encoding=-1) const
| try to read an unicode string
bool | readString (std::vector< uint32_t > &string, std::vector< size_t > &srcPositions, int encoding=-1, bool checkEncryption=false) const
| try to read an unicode string
bool | readStringsPool ()
| try to read a pool of strings
int | getNumPoolNames () const
| return the number of pool name
bool | getPoolName (int poolId, librevenge::RVNGString &res) const
| try to return a pool name
STOFFInputStreamPtr | input ()
| return the zone input
void | setInput (STOFFInputStreamPtr input)
| reset the current input
libstoff::DebugFile & | ascii ()
| returns the ascii file
std::string const & | name () const
| return the zone name

## Protected Member Functions
bool | readRecordSizes (long pos)
| try to read the record sizes
bool | closeRecord (char type, std::string const &debugName)
| try to close a record

## Protected Attributes
STOFFInputStreamPtr | m_input
| the input stream
libstoff::DebugFile | m_ascii
| the ascii zone
int | m_version
| the zone version
int | m_documentVersion
| the document version
std::stack< int > | m_headerVersionStack
| the header version (for SDR zone)
StarEncoding::Encoding | m_encoding
| the zone encoding
int | m_guiType
| the zone GUI type
shared_ptr< StarEncryption > | m_encryption
| the encryption
std::string | m_asciiName
| the file ascii name
std::string | m_zoneName
| the zone name
std::stack< char > | m_typeStack
| the type stack
std::stack< long > | m_positionStack
| the position stack
std::map< long, long > | m_beginToEndMap
| other position to end position zone
long | m_flagEndZone
| end of a cflags zone
std::vector< librevenge::RVNGString > | m_poolList
| the pool name list

## Detailed Description

a zone in a StarOffice file

## Constructor & Destructor Documentation

## ◆ StarZone()

StarZone::StarZone | ( | STOFFInputStreamPtr | input,
|  | std::string const & | ascName,
|  | std::string const & | zoneName,
|  | char const * | password )

constructor

## ◆ ~StarZone()

StarZone::~StarZone | ( |  | ) |
| virtual

destructor

## Member Function Documentation

## ◆ ascii()

libstoff::DebugFile & StarZone::ascii | ( |  | ) |
| inline

returns the ascii file

Referenced by SDGParser::createZones(), StarObject::parse(), StarAttributeBool::read(), StarAttributeColor::read(), StarAttributeDouble::read(), StarAttributeInt::read(), StarAttributeItemSet::read(), StarAttributeUInt::read(), StarAttributeVec2i::read(), StarAttributeVoid::read(), StarCellAttribute::StarCAttributeMargins::read(), StarCellAttribute::StarCAttributeMerge::read(), StarCellAttribute::StarCAttributePattern::read(), StarCellAttribute::StarCAttributeProtection::read(), StarCharAttribute::StarCAttributeCharFormat::read(), StarCharAttribute::StarCAttributeContent::read(), StarCharAttribute::StarCAttributeEscapement::read(), StarCharAttribute::StarCAttributeField::read(), StarCharAttribute::StarCAttributeFont::read(), StarCharAttribute::StarCAttributeFontSize::read(), StarCharAttribute::StarCAttributeFootnote::read(), StarCharAttribute::StarCAttributeINetFmt::read(), StarCharAttribute::StarCAttributeRefMark::read(), StarFrameAttribute::StarFAttributeBorder::read(), StarFrameAttribute::StarFAttributeBrush::read(), StarFrameAttribute::StarFAttributeFrameSize::read(), StarFrameAttribute::StarFAttributeLineNumbering::read(), StarFrameAttribute::StarFAttributeLRSpace::read(), StarFrameAttribute::StarFAttributeOrientation::read(), StarFrameAttribute::StarFAttributeShadow::read(), StarFrameAttribute::StarFAttributeUInt::read(), StarFrameAttribute::StarFAttributeULSpace::read(), StarGraphicAttribute::StarGAttributeBoxInfo::read(), StarGraphicAttribute::StarGAttributeCrop::read(), StarGraphicAttribute::StarGAttributeFraction::read(), StarGraphicAttribute::StarGAttributeNamedArrow::read(), StarGraphicAttribute::StarGAttributeNamedBitmap::read(), StarGraphicAttribute::StarGAttributeNamedColor::read(), StarGraphicAttribute::StarGAttributeNamedDash::read(), StarGraphicAttribute::StarGAttributeNamedGradient::read(), StarGraphicAttribute::StarGAttributeNamedHatch::read(), StarGraphicStruct::StarGraphic::read(), StarLayout::read(), StarObjectModel::read(), StarObjectNumericRuler::read(), StarObjectPageStyle::read(), StarObjectPageStyleInternal::NoteDesc::read(), StarObjectPageStyleInternal::PageDesc::read(), StarObjectSmallText::read(), StarPageAttribute::StarPAttributeColumns::read(), StarPageAttribute::StarPAttributeFrameHF::read(), StarPageAttribute::StarPAttributePage::read(), StarPageAttribute::StarPAttributePageDesc::read(), StarPageAttribute::StarPAttributePageHF::read(), StarPageAttribute::StarPAttributePrint::read(), StarPageAttribute::StarPAttributeRangeItem::read(), StarParagraphAttribute::StarPAttributeAdjust::read(), StarParagraphAttribute::StarPAttributeBulletNumeric::read(), StarParagraphAttribute::StarPAttributeDrop::read(), StarParagraphAttribute::StarPAttributeHyphen::read(), StarParagraphAttribute::StarPAttributeLineSpacing::read(), StarParagraphAttribute::StarPAttributeNumericRuler::read(), StarParagraphAttribute::StarPAttributeTabStop::read(), StarParagraphAttribute::StarPAttributeUInt::read(), StarTableInternal::Table::read(), StarTableInternal::TableBox::read(), StarTableInternal::TableLine::read(), StarWriterStruct::Attribute::read(), StarWriterStruct::Bookmark::read(), StarWriterStruct::DatabaseName::read(), StarWriterStruct::Dictionary::read(), StarWriterStruct::DocStats::read(), StarWriterStruct::Macro::read(), StarWriterStruct::Mark::read(), StarWriterStruct::NodeRedline::read(), StarWriterStruct::NoteInfo::read(), StarWriterStruct::PrintData::read(), StarWriterStruct::Redline::read(), StarWriterStruct::TOX51::read(), StarWriterStruct::TOX::read(), StarAttributeManager::readAttribute(), StarItemPool::readAttribute(), StarObjectNumericRuler::readAttributeLevel(), SDGParser::readBitmap(), StarBitmap::readBitmap(), StarBitmap::readBitmapInformation(), StarLayout::readC1(), StarLayout::readC2(), StarLayout::readC4(), StarObjectSpreadsheet::readCalcDocument(), StarObjectChart::readChartDocument(), StarLayout::readChild(), StarLayout::readD0(), StarLayout::readD8(), StarObjectDraw::readDrawDocument(), StarObjectText::readDrawingLayer(), StarFileManager::readEmbeddedPicture(), SWFieldManager::readField(), StarObjectSmallGraphic::readFmFormObject(), StarFileManager::readFont(), StarLayout::readHeader(), StarItemPool::readItem(), StarObject::readItemSet(), StarFileManager::readJobSetUp(), StarObjectNumericRuler::readLevel(), StarObjectNumericRuler::readList(), StarWriterStruct::Attribute::readList(), StarWriterStruct::Bookmark::readList(), StarWriterStruct::Macro::readList(), StarWriterStruct::Redline::readList(), StarWriterStruct::TOX51::readList(), StarWriterStruct::TOX::readList(), StarWriterStruct::Redline::readListList(), StarFileManager::readMathDocument(), StarFormatManager::readNumberFormat(), StarFormatManager::readNumberFormatter(), StarObject::readPersistData(), StarObject::readPersistElements(), StarObjectDraw::readPresentationData(), StarObjectSpreadsheet::readSCChangeTrack(), StarObjectSpreadsheet::readSCColumn(), StarObjectSpreadsheet::readSCData(), StarObjectSpreadsheet::readSCDBData(), StarObjectSpreadsheet::readSCDBPivot(), StarCellFormula::readSCFormula(), StarCellFormula::readSCFormula3(), StarObjectChart::readSCHAttributes(), StarObjectChart::readSCHMemChart(), StarObjectSmallGraphic::readSCHUObject(), StarObjectSpreadsheet::readSCMatrix(), StarObjectSpreadsheet::readSCOutlineArray(), StarObjectSpreadsheet::readSCQueryParam(), StarObjectSpreadsheet::readSCTable(), StarObjectDraw::readSdrCustomShow(), StarObjectDraw::readSdrFrameView(), StarObjectSmallGraphic::readSDRGluePoint(), StarObjectSmallGraphic::readSDRGluePointList(), StarObjectDraw::readSdrHelpLine(), StarObjectDraw::readSdrHelpLineSet(), StarObjectModel::readSdrLayer(), StarObjectModel::readSdrLayerSet(), StarObjectModel::readSdrMPageDesc(), StarObjectModel::readSdrMPageDescList(), StarObjectSmallGraphic::readSdrObject(), StarObjectSmallGraphic::readSDRObjectConnection(), StarObjectSmallGraphic::readSDRObjectSurrogate(), StarObjectSmallGraphic::readSDROutlinerParaObject(), StarObjectModel::readSdrPage(), StarObjectModel::readSdrPageUnknownZone1(), StarObjectSmallGraphic::readSDRUserData(), StarObjectSmallGraphic::readSDRUserDataList(), StarObjectDraw::readSdrView(), StarObjectSmallGraphic::readSDUDObject(), StarObject::readSfxDocumentInformation(), StarObject::readSfxPreview(), StarObject::readSfxStyleSheets(), StarObjectChart::readSfxStyleSheets(), StarObjectDraw::readSfxStyleSheets(), StarObjectSpreadsheet::readSfxStyleSheets(), StarObjectText::readSfxStyleSheets(), SDGParser::readSGA3(), StarItemPool::readStyles(), StarObjectSmallGraphic::readSVDRObject(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectCaption(), StarObjectSmallGraphic::readSVDRObjectCircle(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), StarObjectSmallGraphic::readSVDRObjectGroup(), StarObjectSmallGraphic::readSVDRObjectHeader(), StarObjectSmallGraphic::readSVDRObjectMeasure(), StarObjectSmallGraphic::readSVDRObjectOLE(), StarObjectSmallGraphic::readSVDRObjectPath(), StarObjectSmallGraphic::readSVDRObjectRect(), StarObjectSmallGraphic::readSVDRObjectText(), StarFileManager::readSVGDI(), StarObjectText::readSWContent(), StarFormatManager::readSWFlyFrameList(), StarFormatManager::readSWFormatDef(), StarObjectText::readSWGraphNode(), StarObjectText::readSWImageMap(), StarObjectText::readSWJobSetUp(), StarFormatManager::readSWNumberFormatterList(), StarObjectText::readSWOLENode(), StarFormatManager::readSWPatternLCL(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), StarItemPool::readV1(), StarItemPool::readV2(), and StarObjectText::readWriterDocument().

## ◆ checkEncryption()

bool StarZone::checkEncryption | ( | uint32_t | date,
|  | uint32_t | time,
|  | std::vector< uint8_t > const & | passwd )

check encryption

Referenced by readSWHeader().

## ◆ closeDummyRecord()

bool StarZone::closeDummyRecord | ( |  | ) |
| inline

close a dummy record

Referenced by StarItemPool::readAttribute().

## ◆ closeFlagZone()

void StarZone::closeFlagZone | ( |  | ) |

close the cflag zone

Referenced by StarLayout::read(), StarObjectNumericRuler::read(), StarObjectPageStyle::read(), StarObjectPageStyleInternal::PageDesc::read(), StarTableInternal::Table::read(), StarTableInternal::TableBox::read(), StarTableInternal::TableLine::read(), StarWriterStruct::Attribute::read(), StarWriterStruct::Bookmark::read(), StarWriterStruct::NodeRedline::read(), StarWriterStruct::NoteInfo::read(), StarWriterStruct::Redline::read(), StarWriterStruct::TOX::read(), SWFieldManager::readField(), StarObjectNumericRuler::readLevel(), StarObjectNumericRuler::readList(), StarWriterStruct::Redline::readList(), readRecordSizes(), StarObjectText::readSWContent(), StarFormatManager::readSWFormatDef(), StarObjectText::readSWGraphNode(), StarObjectText::readSWImageMap(), StarObjectText::readSWJobSetUp(), StarFormatManager::readSWPatternLCL(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), and StarObjectText::readWriterDocument().

## ◆ closeRecord() [1/2]

bool StarZone::closeRecord | ( | char | type,
|  | std::string const & | debugName )
| protected

try to close a record

## ◆ closeRecord() [2/2]

bool StarZone::closeRecord | ( | std::string const & | debugName | ) |
| inline

try to close a record

Referenced by closeDummyRecord(), closeRecord(), closeSCHHeader(), closeSCRecord(), closeSDRHeader(), closeSfxRecord(), closeSWRecord(), closeVersionCompatHeader(), StarObjectModel::read(), StarObjectChart::readChartDocument(), StarObjectSmallGraphic::readFmFormObject(), StarObjectSmallGraphic::readSDRGluePoint(), StarObjectSmallGraphic::readSDRGluePointList(), StarObjectModel::readSdrPage(), StarObjectSmallGraphic::readSDRUserData(), StarObjectSmallGraphic::readSDRUserDataList(), StarObjectDraw::readSdrView(), StarObjectSmallGraphic::readSVDRObject(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectCaption(), StarObjectSmallGraphic::readSVDRObjectCircle(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), StarObjectSmallGraphic::readSVDRObjectGroup(), StarObjectSmallGraphic::readSVDRObjectHeader(), StarObjectSmallGraphic::readSVDRObjectMeasure(), StarObjectSmallGraphic::readSVDRObjectOLE(), StarObjectSmallGraphic::readSVDRObjectPath(), StarObjectSmallGraphic::readSVDRObjectRect(), and StarObjectSmallGraphic::readSVDRObjectText().

## ◆ closeSCHHeader()

bool StarZone::closeSCHHeader | ( | std::string const & | debugName | ) |

close a zone header

Referenced by StarObjectChart::readChartDocument(), StarObjectDraw::readPresentationData(), StarObjectChart::readSCHAttributes(), StarObjectChart::readSCHMemChart(), StarObjectDraw::readSdrCustomShow(), StarObjectDraw::readSdrFrameView(), and StarObjectSmallGraphic::readSDUDObject().

## ◆ closeSCRecord()

bool StarZone::closeSCRecord | ( | std::string const & | debugName | ) |
| inline

try to close a record

Referenced by StarObjectSpreadsheet::readCalcDocument(), StarObject::readPersistData(), StarObjectSpreadsheet::readSCChangeTrack(), StarObjectSpreadsheet::readSCColumn(), StarObjectSpreadsheet::readSCQueryParam(), StarObjectSpreadsheet::readSCTable(), and StarObjectSpreadsheet::readSfxStyleSheets().

## ◆ closeSDRHeader()

bool StarZone::closeSDRHeader | ( | std::string const & | debugName | ) |

close a zone header

Referenced by StarObjectModel::read(), StarObjectDraw::readSdrHelpLine(), StarObjectDraw::readSdrHelpLineSet(), StarObjectModel::readSdrLayer(), StarObjectModel::readSdrLayerSet(), StarObjectModel::readSdrMPageDesc(), StarObjectModel::readSdrMPageDescList(), StarObjectSmallGraphic::readSdrObject(), StarObjectSmallGraphic::readSDRObjectConnection(), StarObjectModel::readSdrPage(), StarObjectDraw::readSdrView(), and StarObjectSmallGraphic::readSVDRObjectGroup().

## ◆ closeSfxRecord()

bool StarZone::closeSfxRecord | ( | char | type,
|  | std::string const & | debugName )
| inline

try to close a record

Referenced by StarItemPool::readStyles(), and StarItemPool::readV2().

## ◆ closeSWRecord()

bool StarZone::closeSWRecord | ( | char | type,
|  | std::string const & | debugName )
| inline

try to close a record

Referenced by StarLayout::read(), StarObjectNumericRuler::read(), StarObjectPageStyle::read(), StarObjectPageStyleInternal::NoteDesc::read(), StarObjectPageStyleInternal::PageDesc::read(), StarTableInternal::Table::read(), StarTableInternal::TableBox::read(), StarTableInternal::TableLine::read(), StarWriterStruct::Attribute::read(), StarWriterStruct::Bookmark::read(), StarWriterStruct::DatabaseName::read(), StarWriterStruct::Dictionary::read(), StarWriterStruct::DocStats::read(), StarWriterStruct::Macro::read(), StarWriterStruct::Mark::read(), StarWriterStruct::NodeRedline::read(), StarWriterStruct::NoteInfo::read(), StarWriterStruct::PrintData::read(), StarWriterStruct::Redline::read(), StarWriterStruct::TOX51::read(), StarWriterStruct::TOX::read(), StarLayout::readC1(), StarLayout::readC2(), StarLayout::readC4(), StarLayout::readChild(), StarLayout::readD0(), StarLayout::readD8(), SWFieldManager::readField(), StarObjectNumericRuler::readLevel(), StarObjectNumericRuler::readList(), StarWriterStruct::Attribute::readList(), StarWriterStruct::Bookmark::readList(), StarWriterStruct::Macro::readList(), StarWriterStruct::Redline::readList(), StarWriterStruct::TOX51::readList(), StarWriterStruct::TOX::readList(), StarWriterStruct::Redline::readListList(), readRecordSizes(), readStringsPool(), StarObjectText::readSWContent(), StarFormatManager::readSWFlyFrameList(), StarFormatManager::readSWFormatDef(), StarObjectText::readSWGraphNode(), StarObjectText::readSWImageMap(), StarObjectText::readSWJobSetUp(), StarFormatManager::readSWNumberFormatterList(), StarObjectText::readSWOLENode(), StarFormatManager::readSWPatternLCL(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), and StarObjectText::readWriterDocument().

## ◆ closeVersionCompatHeader()

bool StarZone::closeVersionCompatHeader | ( | std::string const & | debugName | ) |

close a zone header

Referenced by StarGraphicStruct::StarGraphic::read(), StarFileManager::readEmbeddedPicture(), StarFileManager::readFont(), and StarFileManager::readSVGDI().

## ◆ getDocumentVersion()

int StarZone::getDocumentVersion | ( |  | ) | const
| inline

returns the StarOffice document version

Referenced by StarWriterStruct::Attribute::read().

## ◆ getEncoding()

StarEncoding::Encoding StarZone::getEncoding | ( |  | ) | const
| inline

returns the zone encoding

Referenced by StarCellFormula::readSCToken(), and StarObjectSpreadsheet::readSfxStyleSheets().

## ◆ getFlagLastPosition()

long StarZone::getFlagLastPosition | ( |  | ) | const
| inline

returns the flag last position

Referenced by StarLayout::read(), and StarObjectText::readSWTextZone().

## ◆ getGuiType()

int StarZone::getGuiType | ( |  | ) | const
| inline

returns the zone GUI type

## ◆ getHeaderVersion()

int StarZone::getHeaderVersion | ( |  | ) | const
| inline

returns the StarOffice header version (if set)

Referenced by StarObjectModel::read(), StarObjectChart::readChartDocument(), StarFileManager::readFont(), StarObjectDraw::readPresentationData(), StarObjectChart::readSCHAttributes(), StarObjectChart::readSCHMemChart(), StarObjectDraw::readSdrCustomShow(), StarObjectDraw::readSdrFrameView(), StarObjectDraw::readSdrHelpLine(), StarObjectDraw::readSdrHelpLineSet(), StarObjectModel::readSdrLayer(), StarObjectModel::readSdrLayerSet(), StarObjectModel::readSdrMPageDesc(), StarObjectModel::readSdrMPageDescList(), StarObjectSmallGraphic::readSdrObject(), StarObjectSmallGraphic::readSDRObjectConnection(), StarObjectModel::readSdrPage(), StarObjectDraw::readSdrView(), StarObjectSmallGraphic::readSDUDObject(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), StarObjectSmallGraphic::readSVDRObjectGroup(), StarObjectSmallGraphic::readSVDRObjectHeader(), StarObjectSmallGraphic::readSVDRObjectPath(), StarObjectSmallGraphic::readSVDRObjectRect(), and StarObjectSmallGraphic::readSVDRObjectText().

## ◆ getNumPoolNames()

int StarZone::getNumPoolNames | ( |  | ) | const
| inline

return the number of pool name

Referenced by StarObjectText::readSWContent().

## ◆ getPoolName()

bool StarZone::getPoolName | ( | int | poolId,
|  | librevenge::RVNGString & | res ) const
| inline

try to return a pool name

Referenced by StarCharAttribute::StarCAttributeCharFormat::read(), StarObjectPageStyleInternal::PageDesc::read(), StarPageAttribute::StarPAttributePageDesc::read(), StarTableInternal::TableBox::read(), StarTableInternal::TableLine::read(), StarWriterStruct::TOX51::read(), StarWriterStruct::TOX::read(), StarAttributeManager::readAttribute(), SWFieldManager::readField(), StarObjectNumericRuler::readList(), StarObjectText::readSWContent(), StarFormatManager::readSWFormatDef(), and StarObjectText::readSWTextZone().

## ◆ getRecordLastPosition()

long StarZone::getRecordLastPosition | ( |  | ) | const
| inline

returns the actual record last position

Referenced by StarGraphicStruct::StarGraphic::read(), StarItemPool::read(), StarLayout::read(), StarObjectModel::read(), StarObjectNumericRuler::read(), StarObjectPageStyleInternal::PageDesc::read(), StarTableInternal::Table::read(), StarTableInternal::TableBox::read(), StarTableInternal::TableLine::read(), StarWriterStruct::Attribute::read(), StarWriterStruct::Bookmark::read(), StarWriterStruct::DatabaseName::read(), StarWriterStruct::Dictionary::read(), StarWriterStruct::TOX::read(), StarLayout::readC1(), StarLayout::readC2(), StarLayout::readC4(), StarObjectSpreadsheet::readCalcDocument(), StarObjectChart::readChartDocument(), StarLayout::readChild(), StarLayout::readD0(), StarLayout::readD8(), StarLayout::readDataBlock(), SWFieldManager::readField(), StarObjectSmallGraphic::readFmFormObject(), StarFileManager::readFont(), StarLayout::readHeader(), StarFileManager::readJobSetUp(), StarObjectNumericRuler::readLevel(), StarObjectNumericRuler::readList(), StarWriterStruct::Attribute::readList(), StarWriterStruct::Bookmark::readList(), StarWriterStruct::Macro::readList(), StarWriterStruct::TOX51::readList(), StarWriterStruct::TOX::readList(), StarWriterStruct::Redline::readListList(), StarFormatManager::readNumberFormatter(), StarObject::readPersistData(), StarObjectDraw::readPresentationData(), readRecordSizes(), StarObjectSpreadsheet::readSCChangeTrack(), StarObjectSpreadsheet::readSCColumn(), StarObjectSpreadsheet::readSCData(), StarObjectChart::readSCHAttributes(), StarObjectChart::readSCHMemChart(), StarObjectSpreadsheet::readSCOutlineArray(), StarObjectSpreadsheet::readSCTable(), StarObjectDraw::readSdrCustomShow(), StarObjectDraw::readSdrFrameView(), StarObjectSmallGraphic::readSDRGluePointList(), StarObjectDraw::readSdrHelpLine(), StarObjectDraw::readSdrHelpLineSet(), StarObjectModel::readSdrMPageDescList(), StarObjectSmallGraphic::readSdrObject(), StarObjectSmallGraphic::readSDRObjectConnection(), StarObjectSmallGraphic::readSDRObjectSurrogate(), StarObjectSmallGraphic::readSDROutlinerParaObject(), StarObjectModel::readSdrPage(), StarObjectSmallGraphic::readSDRUserData(), StarObjectSmallGraphic::readSDRUserDataList(), StarObjectDraw::readSdrView(), StarObjectSmallGraphic::readSDUDObject(), StarObjectSpreadsheet::readSfxStyleSheets(), readStringsPool(), StarItemPool::readStyles(), StarObjectSmallGraphic::readSVDRObject(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectCaption(), StarObjectSmallGraphic::readSVDRObjectCircle(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), StarObjectSmallGraphic::readSVDRObjectGroup(), StarObjectSmallGraphic::readSVDRObjectHeader(), StarObjectSmallGraphic::readSVDRObjectMeasure(), StarObjectSmallGraphic::readSVDRObjectOLE(), StarObjectSmallGraphic::readSVDRObjectPath(), StarObjectSmallGraphic::readSVDRObjectText(), StarFileManager::readSVGDI(), StarObjectText::readSWContent(), StarFormatManager::readSWFlyFrameList(), StarFormatManager::readSWFormatDef(), StarObjectText::readSWGraphNode(), StarObjectText::readSWImageMap(), StarObjectText::readSWJobSetUp(), StarFormatManager::readSWNumberFormatterList(), StarFormatManager::readSWPatternLCL(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), StarItemPool::readV1(), StarItemPool::readV2(), and StarObjectText::readWriterDocument().

## ◆ getRecordLevel()

int StarZone::getRecordLevel | ( |  | ) | const
| inline

returns the record level

Referenced by StarAttributeBool::read(), StarAttributeColor::read(), StarAttributeDouble::read(), StarAttributeInt::read(), StarAttributeItemSet::read(), StarAttributeUInt::read(), StarAttributeVec2i::read(), StarAttributeVoid::read(), StarCellAttribute::StarCAttributeMargins::read(), StarCellAttribute::StarCAttributeMerge::read(), StarCellAttribute::StarCAttributePattern::read(), StarCellAttribute::StarCAttributeProtection::read(), StarCharAttribute::StarCAttributeCharFormat::read(), StarCharAttribute::StarCAttributeContent::read(), StarCharAttribute::StarCAttributeEscapement::read(), StarCharAttribute::StarCAttributeField::read(), StarCharAttribute::StarCAttributeFont::read(), StarCharAttribute::StarCAttributeFontSize::read(), StarCharAttribute::StarCAttributeFootnote::read(), StarCharAttribute::StarCAttributeINetFmt::read(), StarCharAttribute::StarCAttributeRefMark::read(), StarFrameAttribute::StarFAttributeBorder::read(), StarFrameAttribute::StarFAttributeBrush::read(), StarFrameAttribute::StarFAttributeFrameSize::read(), StarFrameAttribute::StarFAttributeLineNumbering::read(), StarFrameAttribute::StarFAttributeLRSpace::read(), StarFrameAttribute::StarFAttributeOrientation::read(), StarFrameAttribute::StarFAttributeShadow::read(), StarFrameAttribute::StarFAttributeUInt::read(), StarFrameAttribute::StarFAttributeULSpace::read(), StarGraphicAttribute::StarGAttributeBoxInfo::read(), StarGraphicAttribute::StarGAttributeCrop::read(), StarGraphicAttribute::StarGAttributeFraction::read(), StarGraphicAttribute::StarGAttributeNamedArrow::read(), StarGraphicAttribute::StarGAttributeNamedBitmap::read(), StarGraphicAttribute::StarGAttributeNamedColor::read(), StarGraphicAttribute::StarGAttributeNamedDash::read(), StarGraphicAttribute::StarGAttributeNamedGradient::read(), StarGraphicAttribute::StarGAttributeNamedHatch::read(), StarGraphicStruct::StarGraphic::read(), StarItemPool::read(), StarLayout::read(), StarObjectModel::read(), StarObjectPageStyleInternal::NoteDesc::read(), StarObjectPageStyleInternal::PageDesc::read(), StarPageAttribute::StarPAttributeColumns::read(), StarPageAttribute::StarPAttributeFrameHF::read(), StarPageAttribute::StarPAttributePage::read(), StarPageAttribute::StarPAttributePageDesc::read(), StarPageAttribute::StarPAttributePageHF::read(), StarPageAttribute::StarPAttributePrint::read(), StarPageAttribute::StarPAttributeRangeItem::read(), StarParagraphAttribute::StarPAttributeAdjust::read(), StarParagraphAttribute::StarPAttributeBulletNumeric::read(), StarParagraphAttribute::StarPAttributeDrop::read(), StarParagraphAttribute::StarPAttributeHyphen::read(), StarParagraphAttribute::StarPAttributeLineSpacing::read(), StarParagraphAttribute::StarPAttributeNumericRuler::read(), StarParagraphAttribute::StarPAttributeTabStop::read(), StarParagraphAttribute::StarPAttributeUInt::read(), StarTableInternal::Table::read(), StarTableInternal::TableBox::read(), StarTableInternal::TableLine::read(), StarWriterStruct::Attribute::read(), StarWriterStruct::Bookmark::read(), StarWriterStruct::DatabaseName::read(), StarWriterStruct::Dictionary::read(), StarWriterStruct::DocStats::read(), StarWriterStruct::Macro::read(), StarWriterStruct::Mark::read(), StarWriterStruct::NodeRedline::read(), StarWriterStruct::NoteInfo::read(), StarWriterStruct::PrintData::read(), StarWriterStruct::Redline::read(), StarWriterStruct::TOX51::read(), StarWriterStruct::TOX::read(), StarAttributeManager::readAttribute(), StarItemPool::readAttribute(), StarObjectNumericRuler::readAttributeLevel(), StarBitmap::readBitmap(), StarBitmap::readBitmapInformation(), StarLayout::readC1(), StarLayout::readC2(), StarLayout::readC4(), StarLayout::readChild(), StarLayout::readD0(), StarLayout::readD8(), SWFieldManager::readField(), StarFileManager::readFont(), StarItemPool::readItem(), StarFileManager::readJobSetUp(), StarObjectNumericRuler::readLevel(), StarObjectNumericRuler::readList(), StarWriterStruct::Attribute::readList(), StarWriterStruct::Bookmark::readList(), StarWriterStruct::Macro::readList(), StarWriterStruct::Redline::readList(), StarWriterStruct::TOX51::readList(), StarWriterStruct::TOX::readList(), StarWriterStruct::Redline::readListList(), StarFormatManager::readNumberFormat(), StarFormatManager::readNumberFormatter(), StarObject::readPersistData(), StarObjectSpreadsheet::readSCChangeTrack(), StarObjectSpreadsheet::readSCColumn(), StarObjectSpreadsheet::readSCData(), StarObjectSpreadsheet::readSCDBData(), StarObjectSpreadsheet::readSCDBPivot(), StarCellFormula::readSCFormula(), StarCellFormula::readSCFormula3(), StarObjectChart::readSCHAttributes(), StarObjectChart::readSCHMemChart(), StarObjectSpreadsheet::readSCMatrix(), StarObjectSpreadsheet::readSCOutlineArray(), StarObjectSpreadsheet::readSCQueryParam(), StarObjectSpreadsheet::readSCTable(), StarObjectDraw::readSdrCustomShow(), StarObjectDraw::readSdrFrameView(), StarObjectDraw::readSdrHelpLine(), StarObjectDraw::readSdrHelpLineSet(), StarObjectModel::readSdrLayer(), StarObjectModel::readSdrLayerSet(), StarObjectModel::readSdrMPageDesc(), StarObjectModel::readSdrMPageDescList(), StarObjectSmallGraphic::readSdrObject(), StarObjectSmallGraphic::readSDRObjectConnection(), StarObjectModel::readSdrPage(), StarObjectModel::readSdrPageUnknownZone1(), StarObjectDraw::readSdrView(), readStringsPool(), StarItemPool::readStyles(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectCaption(), StarObjectSmallGraphic::readSVDRObjectCircle(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), StarObjectSmallGraphic::readSVDRObjectGroup(), StarObjectSmallGraphic::readSVDRObjectHeader(), StarObjectSmallGraphic::readSVDRObjectMeasure(), StarObjectSmallGraphic::readSVDRObjectOLE(), StarObjectSmallGraphic::readSVDRObjectPath(), StarObjectSmallGraphic::readSVDRObjectRect(), StarObjectSmallGraphic::readSVDRObjectText(), StarFileManager::readSVGDI(), StarObjectText::readSWContent(), StarFormatManager::readSWFlyFrameList(), StarFormatManager::readSWFormatDef(), StarObjectText::readSWGraphNode(), StarObjectText::readSWImageMap(), StarObjectText::readSWJobSetUp(), StarFormatManager::readSWNumberFormatterList(), StarObjectText::readSWOLENode(), StarFormatManager::readSWPatternLCL(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), StarItemPool::readV1(), and StarItemPool::readV2().

## ◆ getVersion()

int StarZone::getVersion | ( |  | ) | const
| inline

returns the StarOffice version: 3-5

## ◆ input()

STOFFInputStreamPtr StarZone::input | ( |  | ) |
| inline

return the zone input

Referenced by StarItemPool::loadSurrogate(), StarAttributeBool::read(), StarAttributeColor::read(), StarAttributeDouble::read(), StarAttributeInt::read(), StarAttributeItemSet::read(), StarAttributeUInt::read(), StarAttributeVec2i::read(), StarAttributeVoid::read(), StarCellAttribute::StarCAttributeMargins::read(), StarCellAttribute::StarCAttributeMerge::read(), StarCellAttribute::StarCAttributePattern::read(), StarCellAttribute::StarCAttributeProtection::read(), StarCharAttribute::StarCAttributeCharFormat::read(), StarCharAttribute::StarCAttributeContent::read(), StarCharAttribute::StarCAttributeEscapement::read(), StarCharAttribute::StarCAttributeField::read(), StarCharAttribute::StarCAttributeFont::read(), StarCharAttribute::StarCAttributeFontSize::read(), StarCharAttribute::StarCAttributeFootnote::read(), StarCharAttribute::StarCAttributeINetFmt::read(), StarCharAttribute::StarCAttributeRefMark::read(), StarFrameAttribute::StarFAttributeBorder::read(), StarFrameAttribute::StarFAttributeBrush::read(), StarFrameAttribute::StarFAttributeFrameSize::read(), StarFrameAttribute::StarFAttributeLineNumbering::read(), StarFrameAttribute::StarFAttributeLRSpace::read(), StarFrameAttribute::StarFAttributeOrientation::read(), StarFrameAttribute::StarFAttributeShadow::read(), StarFrameAttribute::StarFAttributeUInt::read(), StarFrameAttribute::StarFAttributeULSpace::read(), StarGraphicAttribute::StarGAttributeBoxInfo::read(), StarGraphicAttribute::StarGAttributeCrop::read(), StarGraphicAttribute::StarGAttributeFraction::read(), StarGraphicAttribute::StarGAttributeNamed::read(), StarGraphicAttribute::StarGAttributeNamedArrow::read(), StarGraphicAttribute::StarGAttributeNamedBitmap::read(), StarGraphicAttribute::StarGAttributeNamedColor::read(), StarGraphicAttribute::StarGAttributeNamedDash::read(), StarGraphicAttribute::StarGAttributeNamedGradient::read(), StarGraphicAttribute::StarGAttributeNamedHatch::read(), StarGraphicStruct::StarBrush::read(), StarGraphicStruct::StarGraphic::read(), StarItemPool::read(), StarLayout::read(), StarObjectModel::read(), StarObjectNumericRuler::read(), StarObjectPageStyle::read(), StarObjectPageStyleInternal::NoteDesc::read(), StarObjectPageStyleInternal::PageDesc::read(), StarObjectSmallText::read(), StarPageAttribute::StarPAttributeColumns::read(), StarPageAttribute::StarPAttributeFrameHF::read(), StarPageAttribute::StarPAttributePage::read(), StarPageAttribute::StarPAttributePageDesc::read(), StarPageAttribute::StarPAttributePageHF::read(), StarPageAttribute::StarPAttributePrint::read(), StarPageAttribute::StarPAttributeRangeItem::read(), StarParagraphAttribute::StarPAttributeAdjust::read(), StarParagraphAttribute::StarPAttributeBulletNumeric::read(), StarParagraphAttribute::StarPAttributeDrop::read(), StarParagraphAttribute::StarPAttributeHyphen::read(), StarParagraphAttribute::StarPAttributeLineSpacing::read(), StarParagraphAttribute::StarPAttributeNumericRuler::read(), StarParagraphAttribute::StarPAttributeTabStop::read(), StarParagraphAttribute::StarPAttributeUInt::read(), StarTableInternal::Table::read(), StarTableInternal::TableBox::read(), StarTableInternal::TableLine::read(), StarWriterStruct::Attribute::read(), StarWriterStruct::Bookmark::read(), StarWriterStruct::DatabaseName::read(), StarWriterStruct::Dictionary::read(), StarWriterStruct::DocStats::read(), StarWriterStruct::Macro::read(), StarWriterStruct::Mark::read(), StarWriterStruct::NodeRedline::read(), StarWriterStruct::NoteInfo::read(), StarWriterStruct::PrintData::read(), StarWriterStruct::Redline::read(), StarWriterStruct::TOX51::read(), StarWriterStruct::TOX::read(), StarAttributeManager::readAttribute(), StarItemPool::readAttribute(), StarObjectNumericRuler::readAttributeLevel(), SDGParser::readBitmap(), StarBitmap::readBitmap(), StarBitmap::readBitmapInformation(), StarLayout::readC1(), StarLayout::readC2(), StarLayout::readC4(), StarLayout::readChild(), StarLayout::readD0(), StarLayout::readD8(), StarLayout::readDataBlock(), SWFieldManager::readField(), StarObjectSmallGraphic::readFmFormObject(), StarFileManager::readFont(), StarLayout::readHeader(), StarItemPool::readItem(), StarObject::readItemSet(), StarFileManager::readJobSetUp(), StarObjectNumericRuler::readLevel(), StarObjectNumericRuler::readList(), StarWriterStruct::Attribute::readList(), StarWriterStruct::Bookmark::readList(), StarWriterStruct::Macro::readList(), StarWriterStruct::Redline::readList(), StarWriterStruct::TOX51::readList(), StarWriterStruct::TOX::readList(), StarWriterStruct::Redline::readListList(), StarFormatManager::readNumberFormat(), StarFormatManager::readNumberFormatter(), StarObject::readPersistData(), StarObjectDraw::readPresentationData(), StarObjectSpreadsheet::readSCChangeTrack(), StarObjectSpreadsheet::readSCColumn(), StarObjectSpreadsheet::readSCData(), StarObjectSpreadsheet::readSCDBData(), StarObjectSpreadsheet::readSCDBPivot(), StarCellFormula::readSCFormula(), StarCellFormula::readSCFormula3(), StarObjectChart::readSCHAttributes(), StarObjectChart::readSCHMemChart(), StarObjectSmallGraphic::readSCHUObject(), StarObjectSpreadsheet::readSCMatrix(), StarObjectSpreadsheet::readSCOutlineArray(), StarObjectSpreadsheet::readSCQueryParam(), StarObjectSpreadsheet::readSCTable(), StarCellFormula::readSCToken(), StarCellFormula::readSCToken3(), StarObjectDraw::readSdrCustomShow(), StarObjectDraw::readSdrFrameView(), StarObjectSmallGraphic::readSDRGluePoint(), StarObjectSmallGraphic::readSDRGluePointList(), StarObjectDraw::readSdrHelpLine(), StarObjectDraw::readSdrHelpLineSet(), StarObjectModel::readSdrLayer(), StarObjectModel::readSdrLayerSet(), StarObjectModel::readSdrMPageDesc(), StarObjectModel::readSdrMPageDescList(), StarObjectSmallGraphic::readSdrObject(), StarObjectSmallGraphic::readSDRObjectConnection(), StarObjectSmallGraphic::readSDRObjectSurrogate(), StarObjectSmallGraphic::readSDROutlinerParaObject(), StarObjectModel::readSdrPage(), StarObjectModel::readSdrPageUnknownZone1(), StarObjectSmallGraphic::readSDRUserData(), StarObjectSmallGraphic::readSDRUserDataList(), StarObjectDraw::readSdrView(), StarObjectSmallGraphic::readSDUDObject(), SDGParser::readSGA3(), StarItemPool::readStyles(), StarObjectSmallGraphic::readSVDRObject(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectCaption(), StarObjectSmallGraphic::readSVDRObjectCircle(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), StarObjectSmallGraphic::readSVDRObjectGroup(), StarObjectSmallGraphic::readSVDRObjectHeader(), StarObjectSmallGraphic::readSVDRObjectMeasure(), StarObjectSmallGraphic::readSVDRObjectOLE(), StarObjectSmallGraphic::readSVDRObjectPath(), StarObjectSmallGraphic::readSVDRObjectRect(), StarObjectSmallGraphic::readSVDRObjectText(), StarFileManager::readSVGDI(), StarObjectText::readSWContent(), StarFormatManager::readSWFlyFrameList(), StarFormatManager::readSWFormatDef(), StarObjectText::readSWGraphNode(), StarObjectText::readSWImageMap(), StarObjectText::readSWJobSetUp(), StarFormatManager::readSWNumberFormatterList(), StarObjectText::readSWOLENode(), StarFormatManager::readSWPatternLCL(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), StarItemPool::readV1(), and StarItemPool::readV2().

## ◆ isCompatibleWith() [1/4]

int StarZone::isCompatibleWith | ( | int | vers | ) | const
| inline

checks if the document is compatible with vers

Referenced by openSWRecord(), StarObjectPageStyleInternal::PageDesc::read(), StarTableInternal::Table::read(), StarTableInternal::TableBox::read(), StarTableInternal::TableLine::read(), StarWriterStruct::DatabaseName::read(), StarWriterStruct::DocStats::read(), StarWriterStruct::Macro::read(), StarWriterStruct::NoteInfo::read(), StarWriterStruct::TOX51::read(), StarWriterStruct::TOX::read(), SWFieldManager::readField(), StarObjectNumericRuler::readLevel(), StarObjectNumericRuler::readList(), readRecordSizes(), readStringsPool(), StarObjectText::readSWContent(), StarFormatManager::readSWFormatDef(), StarObjectText::readSWGraphNode(), readSWHeader(), StarObjectText::readSWImageMap(), StarObjectText::readSWOLENode(), StarFormatManager::readSWPatternLCL(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), and StarObjectText::readWriterDocument().

## ◆ isCompatibleWith() [2/4]

int StarZone::isCompatibleWith | ( | int | vers1,
|  | int | vers2 ) const
| inline

checks if the document is compatible with vers1 and not vers2

## ◆ isCompatibleWith() [3/4]

int StarZone::isCompatibleWith | ( | int | vers1,
|  | int | vers2,
|  | int | vers3 ) const
| inline

checks if the document is compatible with vers1 and not vers2 or vers3

## ◆ isCompatibleWith() [4/4]

int StarZone::isCompatibleWith | ( | int | vers1,
|  | int | vers2,
|  | int | vers3,
|  | int | vers4 ) const
| inline

checks if the document is compatible with vers1 and not vers2 or vers3 and not vers4

## ◆ name()

std::string const & StarZone::name | ( |  | ) | const
| inline

return the zone name

## ◆ openDummyRecord()

bool StarZone::openDummyRecord | ( |  | ) |

open a dummy record

Referenced by StarItemPool::readAttribute().

## ◆ openFlagZone()

unsigned char StarZone::openFlagZone | ( |  | ) |

try to open a cflag zone

Referenced by StarLayout::read(), StarObjectNumericRuler::read(), StarObjectPageStyle::read(), StarObjectPageStyleInternal::PageDesc::read(), StarTableInternal::Table::read(), StarTableInternal::TableBox::read(), StarTableInternal::TableLine::read(), StarWriterStruct::Attribute::read(), StarWriterStruct::Bookmark::read(), StarWriterStruct::NodeRedline::read(), StarWriterStruct::NoteInfo::read(), StarWriterStruct::Redline::read(), StarWriterStruct::TOX51::read(), StarWriterStruct::TOX::read(), SWFieldManager::readField(), StarObjectNumericRuler::readLevel(), StarObjectNumericRuler::readList(), StarWriterStruct::Redline::readList(), readRecordSizes(), StarObjectText::readSWContent(), StarFormatManager::readSWFormatDef(), StarObjectText::readSWGraphNode(), StarObjectText::readSWImageMap(), StarObjectText::readSWJobSetUp(), StarFormatManager::readSWPatternLCL(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), and StarObjectText::readWriterDocument().

## ◆ openRecord()

bool StarZone::openRecord | ( |  | ) |

try to open a classic record: size (32 bytes) + size-4 bytes

Referenced by StarObjectModel::read(), StarObjectChart::readChartDocument(), StarObjectSmallGraphic::readFmFormObject(), StarObjectSmallGraphic::readSDRGluePoint(), StarObjectSmallGraphic::readSDRGluePointList(), StarObjectModel::readSdrPage(), StarObjectSmallGraphic::readSDRUserData(), StarObjectSmallGraphic::readSDRUserDataList(), StarObjectDraw::readSdrView(), StarObjectSmallGraphic::readSVDRObject(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectCaption(), StarObjectSmallGraphic::readSVDRObjectCircle(), StarObjectSmallGraphic::readSVDRObjectEdge(), StarObjectSmallGraphic::readSVDRObjectGraph(), StarObjectSmallGraphic::readSVDRObjectGroup(), StarObjectSmallGraphic::readSVDRObjectHeader(), StarObjectSmallGraphic::readSVDRObjectMeasure(), StarObjectSmallGraphic::readSVDRObjectOLE(), StarObjectSmallGraphic::readSVDRObjectPath(), StarObjectSmallGraphic::readSVDRObjectRect(), and StarObjectSmallGraphic::readSVDRObjectText().

## ◆ openSCHHeader()

bool StarZone::openSCHHeader | ( |  | ) |

open a zone header present in a SCH file

Referenced by StarObjectChart::readChartDocument(), StarObjectDraw::readPresentationData(), StarObjectChart::readSCHAttributes(), StarObjectChart::readSCHMemChart(), StarObjectDraw::readSdrCustomShow(), StarObjectDraw::readSdrFrameView(), and StarObjectSmallGraphic::readSDUDObject().

## ◆ openSCRecord()

bool StarZone::openSCRecord | ( |  | ) |

try to open a SC record: size (32 bytes) + size bytes

Referenced by StarObjectSpreadsheet::readCalcDocument(), StarObject::readPersistData(), StarObjectSpreadsheet::readSCChangeTrack(), StarObjectSpreadsheet::readSCColumn(), StarObjectSpreadsheet::readSCQueryParam(), StarObjectSpreadsheet::readSCTable(), and StarObjectSpreadsheet::readSfxStyleSheets().

## ◆ openSDRHeader()

bool StarZone::openSDRHeader | ( | std::string & | magic | ) |

open a zone header present in a SDR file

Referenced by StarObjectModel::read(), StarObjectDraw::readSdrHelpLine(), StarObjectDraw::readSdrHelpLineSet(), StarObjectModel::readSdrLayer(), StarObjectModel::readSdrLayerSet(), StarObjectModel::readSdrMPageDesc(), StarObjectModel::readSdrMPageDescList(), StarObjectSmallGraphic::readSdrObject(), StarObjectSmallGraphic::readSDRObjectConnection(), StarObjectModel::readSdrPage(), StarObjectDraw::readSdrView(), and StarObjectSmallGraphic::readSVDRObjectGroup().

## ◆ openSfxRecord()

bool StarZone::openSfxRecord | ( | char & | type | ) |

try to open a Sfx record: type + size (24 bytes)

Referenced by StarItemPool::readStyles(), and StarItemPool::readV2().

## ◆ openSWRecord()

bool StarZone::openSWRecord | ( | char & | type | ) |

try to open a SW record: type + size (24 bytes)

Referenced by StarLayout::read(), StarObjectNumericRuler::read(), StarObjectPageStyle::read(), StarObjectPageStyleInternal::NoteDesc::read(), StarObjectPageStyleInternal::PageDesc::read(), StarTableInternal::Table::read(), StarTableInternal::TableBox::read(), StarTableInternal::TableLine::read(), StarWriterStruct::Attribute::read(), StarWriterStruct::Bookmark::read(), StarWriterStruct::DatabaseName::read(), StarWriterStruct::Dictionary::read(), StarWriterStruct::DocStats::read(), StarWriterStruct::Macro::read(), StarWriterStruct::Mark::read(), StarWriterStruct::NodeRedline::read(), StarWriterStruct::NoteInfo::read(), StarWriterStruct::PrintData::read(), StarWriterStruct::Redline::read(), StarWriterStruct::TOX51::read(), StarWriterStruct::TOX::read(), StarLayout::readC1(), StarLayout::readC2(), StarLayout::readC4(), StarLayout::readChild(), StarLayout::readD0(), StarLayout::readD8(), SWFieldManager::readField(), StarObjectNumericRuler::readLevel(), StarObjectNumericRuler::readList(), StarWriterStruct::Attribute::readList(), StarWriterStruct::Bookmark::readList(), StarWriterStruct::Macro::readList(), StarWriterStruct::Redline::readList(), StarWriterStruct::TOX51::readList(), StarWriterStruct::TOX::readList(), StarWriterStruct::Redline::readListList(), readRecordSizes(), readStringsPool(), StarObjectText::readSWContent(), StarFormatManager::readSWFlyFrameList(), StarFormatManager::readSWFormatDef(), StarObjectText::readSWGraphNode(), StarObjectText::readSWImageMap(), StarObjectText::readSWJobSetUp(), StarFormatManager::readSWNumberFormatterList(), StarObjectText::readSWOLENode(), StarFormatManager::readSWPatternLCL(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), and StarObjectText::readWriterDocument().

## ◆ openVersionCompatHeader()

bool StarZone::openVersionCompatHeader | ( |  | ) |

open a version compat header (version+size)

Referenced by StarGraphicStruct::StarGraphic::read(), StarFileManager::readEmbeddedPicture(), StarFileManager::readFont(), and StarFileManager::readSVGDI().

## ◆ readRecordSizes()

bool StarZone::readRecordSizes | ( | long | pos | ) |
| protected

try to read the record sizes

Referenced by readSWHeader().

## ◆ readString() [1/2]

bool StarZone::readString | ( | std::vector< uint32_t > & | string,
|  | int | encoding = -1 ) const
| inline

try to read an unicode string

Referenced by StarCellAttribute::StarCAttributePattern::read(), StarCharAttribute::StarCAttributeFont::read(), StarCharAttribute::StarCAttributeFootnote::read(), StarCharAttribute::StarCAttributeINetFmt::read(), StarCharAttribute::StarCAttributeRefMark::read(), StarGraphicAttribute::StarGAttributeNamed::read(), StarGraphicStruct::StarBrush::read(), StarObjectModel::read(), StarObjectSmallText::read(), StarPageAttribute::StarPAttributePage::read(), StarParagraphAttribute::StarPAttributeNumericRuler::read(), StarWriterStruct::Bookmark::read(), StarWriterStruct::DatabaseName::read(), StarWriterStruct::Dictionary::read(), StarWriterStruct::Macro::read(), StarWriterStruct::NoteInfo::read(), StarWriterStruct::Redline::read(), StarWriterStruct::TOX51::read(), StarWriterStruct::TOX::read(), StarAttributeManager::readAttribute(), StarObjectNumericRuler::readAttributeLevel(), SDGParser::readBitmap(), StarObjectSpreadsheet::readCalcDocument(), SWFieldManager::readField(), StarObjectSmallGraphic::readFmFormObject(), StarFileManager::readFont(), StarFileManager::readJobSetUp(), StarObjectNumericRuler::readLevel(), StarFileManager::readMathDocument(), StarFormatManager::readNumberFormat(), StarFormatManager::readNumberFormatter(), StarObject::readPersistData(), StarObjectDraw::readPresentationData(), StarObjectSpreadsheet::readSCChangeTrack(), StarObjectSpreadsheet::readSCColumn(), StarObjectSpreadsheet::readSCData(), StarObjectSpreadsheet::readSCDBData(), StarObjectSpreadsheet::readSCDBPivot(), StarObjectChart::readSCHAttributes(), StarObjectChart::readSCHMemChart(), StarObjectSpreadsheet::readSCMatrix(), StarObjectSpreadsheet::readSCQueryParam(), StarObjectSpreadsheet::readSCTable(), StarCellFormula::readSCToken3(), StarObjectDraw::readSdrCustomShow(), StarObjectModel::readSdrLayer(), StarObjectModel::readSdrLayerSet(), StarObjectSmallGraphic::readSDROutlinerParaObject(), StarObjectModel::readSdrPage(), StarObjectModel::readSdrPageUnknownZone1(), StarObjectSmallGraphic::readSDUDObject(), readString(), readStringsPool(), StarItemPool::readStyles(), StarObjectSmallGraphic::readSVDRObject(), StarObjectSmallGraphic::readSVDRObjectAttrib(), StarObjectSmallGraphic::readSVDRObjectGraph(), StarObjectSmallGraphic::readSVDRObjectGroup(), StarObjectSmallGraphic::readSVDRObjectOLE(), StarFileManager::readSVGDI(), StarFormatManager::readSWFormatDef(), StarObjectText::readSWGraphNode(), StarObjectText::readSWImageMap(), StarObjectText::readSWOLENode(), StarFormatManager::readSWPatternLCL(), StarObjectText::readSWSection(), StarObjectText::readSWTextZone(), StarItemPool::readV1(), StarItemPool::readV2(), and StarObjectText::readWriterDocument().

## ◆ readString() [2/2]

bool StarZone::readString | ( | std::vector< uint32_t > & | string,
|  | std::vector< size_t > & | srcPositions,
|  | int | encoding = -1,
|  | bool | checkEncryption = false ) const

try to read an unicode string

## ◆ readStringsPool()

bool StarZone::readStringsPool | ( |  | ) |

try to read a pool of strings

Referenced by StarObjectNumericRuler::read(), StarObjectPageStyle::read(), and StarObjectText::readWriterDocument().

## ◆ readSWHeader()

bool StarZone::readSWHeader | ( |  | ) |

read the zone header present in a SW file

Referenced by StarObjectNumericRuler::read(), StarObjectPageStyle::read(), and StarObjectText::readWriterDocument().

## ◆ setEncoding()

void StarZone::setEncoding | ( | StarEncoding::Encoding | encod | ) |
| inline

sets the zone encoding

Referenced by StarObjectModel::read(), StarObjectSpreadsheet::readCalcDocument(), and StarObjectSpreadsheet::readSfxStyleSheets().

## ◆ setGuiType()

void StarZone::setGuiType | ( | int | type | ) |
| inline

sets the zone GUI type

Referenced by StarObjectSpreadsheet::readCalcDocument(), and StarObjectSpreadsheet::readSfxStyleSheets().

## ◆ setInput()

void StarZone::setInput | ( | STOFFInputStreamPtr | input | ) |

reset the current input

Referenced by StarObjectSpreadsheet::readCalcDocument(), and StarObjectDraw::readDrawDocument().

## Member Data Documentation

## ◆ m_ascii

libstoff::DebugFile StarZone::m_ascii
| protected

the ascii zone

Referenced by ascii(), closeFlagZone(), closeRecord(), readRecordSizes(), readStringsPool(), readSWHeader(), setInput(), StarZone(), and ~StarZone().

## ◆ m_asciiName

std::string StarZone::m_asciiName
| protected

the file ascii name

Referenced by readSWHeader(), and StarZone().

## ◆ m_beginToEndMap

std::map<long, long> StarZone::m_beginToEndMap
| protected

other position to end position zone

Referenced by openSWRecord(), readRecordSizes(), and StarZone().

## ◆ m_documentVersion

int StarZone::m_documentVersion
| protected

the document version

Referenced by getDocumentVersion(), isCompatibleWith(), isCompatibleWith(), isCompatibleWith(), isCompatibleWith(), readSWHeader(), and StarZone().

## ◆ m_encoding

StarEncoding::Encoding StarZone::m_encoding
| protected

the zone encoding

Referenced by getEncoding(), readString(), readStringsPool(), readSWHeader(), setEncoding(), and StarZone().

## ◆ m_encryption

shared_ptr<StarEncryption> StarZone::m_encryption
| protected

the encryption

Referenced by checkEncryption(), readString(), readSWHeader(), and StarZone().

## ◆ m_flagEndZone

long StarZone::m_flagEndZone
| protected

end of a cflags zone

Referenced by closeFlagZone(), closeRecord(), getFlagLastPosition(), openFlagZone(), openRecord(), openSCRecord(), openSfxRecord(), openSWRecord(), and StarZone().

## ◆ m_guiType

int StarZone::m_guiType
| protected

the zone GUI type

Referenced by getGuiType(), setGuiType(), and StarZone().

## ◆ m_headerVersionStack

std::stack<int> StarZone::m_headerVersionStack
| protected

the header version (for SDR zone)

Referenced by closeSCHHeader(), closeSDRHeader(), closeVersionCompatHeader(), getHeaderVersion(), openSCHHeader(), openSDRHeader(), openVersionCompatHeader(), and StarZone().

## ◆ m_input

STOFFInputStreamPtr StarZone::m_input
| protected

the input stream

Referenced by closeFlagZone(), closeRecord(), input(), openDummyRecord(), openFlagZone(), openRecord(), openSCHHeader(), openSCRecord(), openSDRHeader(), openSfxRecord(), openSWRecord(), openVersionCompatHeader(), readRecordSizes(), readString(), readStringsPool(), readSWHeader(), setInput(), and StarZone().

## ◆ m_poolList

std::vector<librevenge::RVNGString> StarZone::m_poolList
| protected

the pool name list

Referenced by getNumPoolNames(), getPoolName(), readStringsPool(), and StarZone().

## ◆ m_positionStack

std::stack<long> StarZone::m_positionStack
| protected

the position stack

Referenced by closeRecord(), getRecordLastPosition(), getRecordLevel(), openDummyRecord(), openRecord(), openSCHHeader(), openSCRecord(), openSDRHeader(), openSfxRecord(), openSWRecord(), openVersionCompatHeader(), and StarZone().

## ◆ m_typeStack

std::stack<char> StarZone::m_typeStack
| protected

the type stack

Referenced by closeRecord(), openDummyRecord(), openRecord(), openSCHHeader(), openSCRecord(), openSDRHeader(), openSfxRecord(), openSWRecord(), openVersionCompatHeader(), and StarZone().

## ◆ m_version

int StarZone::m_version
| protected

the zone version

Referenced by getVersion(), readSWHeader(), and StarZone().

## ◆ m_zoneName

std::string StarZone::m_zoneName
| protected

the zone name

Referenced by name(), readRecordSizes(), readSWHeader(), and StarZone().

The documentation for this class was generated from the following files:

- StarZone.hxx
- StarZone.cxx